diff mbox

[01/15,v2] btrfs: new test to run btrfs balance and subvolume test simultaneously

Message ID 1409233676-22787-2-git-send-email-eguan@redhat.com (mailing list archive)
State New, archived
Headers show

Commit Message

Eryu Guan Aug. 28, 2014, 1:47 p.m. UTC
Run btrfs balance and subvolume create/mount/umount/delete simultaneously,
with fsstress running in background.

Signed-off-by: Eryu Guan <eguan@redhat.com>
---
 common/rc           |  24 ++++++++++
 tests/btrfs/059     | 129 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/btrfs/059.out |   2 +
 tests/btrfs/group   |   1 +
 4 files changed, 156 insertions(+)
 create mode 100755 tests/btrfs/059
 create mode 100644 tests/btrfs/059.out

Comments

Dave Chinner Sept. 8, 2014, 10:01 a.m. UTC | #1
On Thu, Aug 28, 2014 at 09:47:42PM +0800, Eryu Guan wrote:
> Run btrfs balance and subvolume create/mount/umount/delete simultaneously,
> with fsstress running in background.
> 
> Signed-off-by: Eryu Guan <eguan@redhat.com>
> ---
>  common/rc           |  24 ++++++++++
>  tests/btrfs/059     | 129 ++++++++++++++++++++++++++++++++++++++++++++++++++++
>  tests/btrfs/059.out |   2 +
>  tests/btrfs/group   |   1 +
>  4 files changed, 156 insertions(+)
>  create mode 100755 tests/btrfs/059
>  create mode 100644 tests/btrfs/059.out
> 
> diff --git a/common/rc b/common/rc
> index 16da898..c1a7b9e 100644
> --- a/common/rc
> +++ b/common/rc
> @@ -2375,6 +2375,30 @@ _get_free_inode()
>  	echo $nr_inode
>  }
>  
> +_btrfs_stress_balance()
> +{
> +	local btrfs_mnt=$1
> +	while true; do
> +		$BTRFS_UTIL_PROG balance start $btrfs_mnt
> +	done
> +}
> +
> +_btrfs_stress_subvolume()
> +{
> +	local btrfs_dev=$1
> +	local btrfs_mnt=$2
> +	local subvol_name=$3
> +	local subvol_mnt=$4
> +
> +	mkdir -p $subvol_mnt
> +	while true; do
> +		$BTRFS_UTIL_PROG subvolume create $btrfs_mnt/$subvol_name
> +		$MOUNT_PROG -o subvol=$subvol_name $btrfs_dev $subvol_mnt
> +		$UMOUNT_PROG $subvol_mnt
> +		$BTRFS_UTIL_PROG subvolume delete $btrfs_mnt/$subvol_name
> +	done
> +}
> +

I'm thinking that we need to start separating common/rc in
filesystem specific include files. Not necessary for this series,
but we really need to so using this file as a dumping ground for
shared code rather than for init and config stuff.

> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +status=1
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +_cleanup()
> +{
> +	cd /
> +	rm -fr $tmp.*
> +}

Really dangerous, that. if $tmp is empty, then that will remove
everything under / (i.e. 'cd /; rm -rf .*'). You shouldn't be using
subdirs under $tmp - if you need lots of temporary data for the
test, it should be under $TESTDIR, not on the root filesystem.

> +run_test()
> +{
> +	local mkfs_opts=$1
> +	local subvol_mnt=$tmp.mnt

IOWs, don't do this. Mount stuff under $TESTDIR/$seq.mnt. That's
what the testdir is there for...

Cheers,

Dave.
Eryu Guan Sept. 9, 2014, 11:53 a.m. UTC | #2
On Mon, Sep 08, 2014 at 08:01:27PM +1000, Dave Chinner wrote:
> On Thu, Aug 28, 2014 at 09:47:42PM +0800, Eryu Guan wrote:
> > Run btrfs balance and subvolume create/mount/umount/delete simultaneously,
> > with fsstress running in background.
> > 
> > Signed-off-by: Eryu Guan <eguan@redhat.com>
> > ---
> >  common/rc           |  24 ++++++++++
> >  tests/btrfs/059     | 129 ++++++++++++++++++++++++++++++++++++++++++++++++++++
> >  tests/btrfs/059.out |   2 +
> >  tests/btrfs/group   |   1 +
> >  4 files changed, 156 insertions(+)
> >  create mode 100755 tests/btrfs/059
> >  create mode 100644 tests/btrfs/059.out
> > 
> > diff --git a/common/rc b/common/rc
> > index 16da898..c1a7b9e 100644
> > --- a/common/rc
> > +++ b/common/rc
> > @@ -2375,6 +2375,30 @@ _get_free_inode()
> >  	echo $nr_inode
> >  }
> >  
> > +_btrfs_stress_balance()
> > +{
> > +	local btrfs_mnt=$1
> > +	while true; do
> > +		$BTRFS_UTIL_PROG balance start $btrfs_mnt
> > +	done
> > +}
> > +
> > +_btrfs_stress_subvolume()
> > +{
> > +	local btrfs_dev=$1
> > +	local btrfs_mnt=$2
> > +	local subvol_name=$3
> > +	local subvol_mnt=$4
> > +
> > +	mkdir -p $subvol_mnt
> > +	while true; do
> > +		$BTRFS_UTIL_PROG subvolume create $btrfs_mnt/$subvol_name
> > +		$MOUNT_PROG -o subvol=$subvol_name $btrfs_dev $subvol_mnt
> > +		$UMOUNT_PROG $subvol_mnt
> > +		$BTRFS_UTIL_PROG subvolume delete $btrfs_mnt/$subvol_name
> > +	done
> > +}
> > +
> 
> I'm thinking that we need to start separating common/rc in
> filesystem specific include files. Not necessary for this series,
> but we really need to so using this file as a dumping ground for
> shared code rather than for init and config stuff.

Agreed, maybe I can add one more patch as a last patch to sort out all
btrfs shared code to common/btrfs

> 
> > +echo "QA output created by $seq"
> > +
> > +here=`pwd`
> > +tmp=/tmp/$$
> > +status=1
> > +trap "_cleanup; exit \$status" 0 1 2 3 15
> > +
> > +_cleanup()
> > +{
> > +	cd /
> > +	rm -fr $tmp.*
> > +}
> 
> Really dangerous, that. if $tmp is empty, then that will remove
> everything under / (i.e. 'cd /; rm -rf .*'). You shouldn't be using
> subdirs under $tmp - if you need lots of temporary data for the
> test, it should be under $TESTDIR, not on the root filesystem.

Makes much sense! Will change it.

Thanks,
Eryu
> 
> > +run_test()
> > +{
> > +	local mkfs_opts=$1
> > +	local subvol_mnt=$tmp.mnt
> 
> IOWs, don't do this. Mount stuff under $TESTDIR/$seq.mnt. That's
> what the testdir is there for...
> 
> Cheers,
> 
> Dave.
> -- 
> Dave Chinner
> david@fromorbit.com
--
To unsubscribe from this list: send the line "unsubscribe linux-btrfs" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
Eric Sandeen Sept. 9, 2014, 3:41 p.m. UTC | #3
On 9/8/14 5:01 AM, Dave Chinner wrote:
> On Thu, Aug 28, 2014 at 09:47:42PM +0800, Eryu Guan wrote:
>> Run btrfs balance and subvolume create/mount/umount/delete simultaneously,
>> with fsstress running in background.
>>
>> Signed-off-by: Eryu Guan <eguan@redhat.com>
>> ---
>>   common/rc           |  24 ++++++++++
>>   tests/btrfs/059     | 129 ++++++++++++++++++++++++++++++++++++++++++++++++++++
>>   tests/btrfs/059.out |   2 +
>>   tests/btrfs/group   |   1 +
>>   4 files changed, 156 insertions(+)
>>   create mode 100755 tests/btrfs/059
>>   create mode 100644 tests/btrfs/059.out
>>
>> diff --git a/common/rc b/common/rc
>> index 16da898..c1a7b9e 100644
>> --- a/common/rc
>> +++ b/common/rc
>> @@ -2375,6 +2375,30 @@ _get_free_inode()
>>   	echo $nr_inode
>>   }
>>
>> +_btrfs_stress_balance()
>> +{
>> +	local btrfs_mnt=$1
>> +	while true; do
>> +		$BTRFS_UTIL_PROG balance start $btrfs_mnt
>> +	done
>> +}
>> +
>> +_btrfs_stress_subvolume()
>> +{
>> +	local btrfs_dev=$1
>> +	local btrfs_mnt=$2
>> +	local subvol_name=$3
>> +	local subvol_mnt=$4
>> +
>> +	mkdir -p $subvol_mnt
>> +	while true; do
>> +		$BTRFS_UTIL_PROG subvolume create $btrfs_mnt/$subvol_name
>> +		$MOUNT_PROG -o subvol=$subvol_name $btrfs_dev $subvol_mnt
>> +		$UMOUNT_PROG $subvol_mnt
>> +		$BTRFS_UTIL_PROG subvolume delete $btrfs_mnt/$subvol_name
>> +	done
>> +}
>> +
>
> I'm thinking that we need to start separating common/rc in
> filesystem specific include files. Not necessary for this series,
> but we really need to so using this file as a dumping ground for
> shared code rather than for init and config stuff.
>
>> +echo "QA output created by $seq"
>> +
>> +here=`pwd`
>> +tmp=/tmp/$$
>> +status=1
>> +trap "_cleanup; exit \$status" 0 1 2 3 15
>> +
>> +_cleanup()
>> +{
>> +	cd /
>> +	rm -fr $tmp.*
>> +}
>
> Really dangerous, that. if $tmp is empty, then that will remove
> everything under / (i.e. 'cd /; rm -rf .*'). You shouldn't be using
> subdirs under $tmp - if you need lots of temporary data for the
> test, it should be under $TESTDIR, not on the root filesystem.

FWIW, there are a several other tests which do this, at least:

tests/generic/003-1356-    cd /
tests/generic/003:1365:    rm -rf $tmp.*

tests/generic/273-1120-	cd /
tests/generic/273:1126:	rm -rf $tmp.*

tests/generic/320-1280-	cd /
tests/generic/320:1286:	rm -rf $tmp.*

tests/xfs/287-1248-	cd /
tests/xfs/287-1254-	umount $SCRATCH_MNT 2>/dev/null
tests/xfs/287:1287:	rm -rf $tmp.*

Should probably clean those up for safety and to avoid further cut and paste ...

-Eric
--
To unsubscribe from this list: send the line "unsubscribe linux-btrfs" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
Dave Chinner Sept. 9, 2014, 11:53 p.m. UTC | #4
On Tue, Sep 09, 2014 at 07:53:24PM +0800, Eryu Guan wrote:
> On Mon, Sep 08, 2014 at 08:01:27PM +1000, Dave Chinner wrote:
> > I'm thinking that we need to start separating common/rc in
> > filesystem specific include files. Not necessary for this series,
> > but we really need to so using this file as a dumping ground for
> > shared code rather than for init and config stuff.
> 
> Agreed, maybe I can add one more patch as a last patch to sort out all
> btrfs shared code to common/btrfs

Better to do a separate series where all the different
per-filesystem functionality is moved about rather than do it on an
ad hoc, one filesystem at a time basis. If I find some time in the
next few days, I'll look at doing this.

Cheers,

Dave.
diff mbox

Patch

diff --git a/common/rc b/common/rc
index 16da898..c1a7b9e 100644
--- a/common/rc
+++ b/common/rc
@@ -2375,6 +2375,30 @@  _get_free_inode()
 	echo $nr_inode
 }
 
+_btrfs_stress_balance()
+{
+	local btrfs_mnt=$1
+	while true; do
+		$BTRFS_UTIL_PROG balance start $btrfs_mnt
+	done
+}
+
+_btrfs_stress_subvolume()
+{
+	local btrfs_dev=$1
+	local btrfs_mnt=$2
+	local subvol_name=$3
+	local subvol_mnt=$4
+
+	mkdir -p $subvol_mnt
+	while true; do
+		$BTRFS_UTIL_PROG subvolume create $btrfs_mnt/$subvol_name
+		$MOUNT_PROG -o subvol=$subvol_name $btrfs_dev $subvol_mnt
+		$UMOUNT_PROG $subvol_mnt
+		$BTRFS_UTIL_PROG subvolume delete $btrfs_mnt/$subvol_name
+	done
+}
+
 init_rc()
 {
 	if [ "$iam" == new ]
diff --git a/tests/btrfs/059 b/tests/btrfs/059
new file mode 100755
index 0000000..817facb
--- /dev/null
+++ b/tests/btrfs/059
@@ -0,0 +1,129 @@ 
+#! /bin/bash
+# FSQA Test No. btrfs/059
+#
+# Run btrfs balance and subvolume create/mount/umount/delete simultaneously,
+# with fsstress running in background.
+#
+#-----------------------------------------------------------------------
+# Copyright (C) 2014 Red Hat Inc. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -fr $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_fs btrfs
+_supported_os Linux
+_require_scratch
+_require_scratch_dev_pool 4
+
+rm -f $seqres.full
+
+# test case array
+tcs=(
+	"-m single -d single"
+	"-m dup -d single"
+	"-m raid0 -d raid0"
+	"-m raid1 -d raid0"
+	"-m raid1 -d raid1"
+	"-m raid10 -d raid10"
+	"-m raid5 -d raid5"
+	"-m raid6 -d raid6"
+)
+
+run_test()
+{
+	local mkfs_opts=$1
+	local subvol_mnt=$tmp.mnt
+
+	echo "Test $mkfs_opts" >>$seqres.full
+
+	# dup only works on single device
+	if [[ "$mkfs_opts" =~ dup ]]; then
+		_scratch_mkfs $mkfs_opts >>$seqres.full 2>&1
+	else
+		_scratch_pool_mkfs $mkfs_opts >>$seqres.full 2>&1
+	fi
+	# make sure we created btrfs with desired options
+	if [ $? -ne 0 ]; then
+		echo "mkfs $mkfs_opts failed" | tee -a $seqres.full
+		return
+	fi
+	_scratch_mount >>$seqres.full 2>&1
+
+	args=`_scale_fsstress_args -p 20 -n 100 $FSSTRESS_AVOID -d $SCRATCH_MNT/stressdir`
+	echo "Run fsstress $args" >>$seqres.full
+	$FSSTRESS_PROG $args >/dev/null 2>&1 &
+	fsstress_pid=$!
+
+	echo -n "Start balance worker: " >>$seqres.full
+	_btrfs_stress_balance $SCRATCH_MNT >/dev/null 2>&1 &
+	balance_pid=$!
+	echo "$balance_pid" >>$seqres.full
+
+	echo -n "Start subvolume worker: " >>$seqres.full
+	_btrfs_stress_subvolume $SCRATCH_DEV $SCRATCH_MNT subvol_$$ $subvol_mnt >/dev/null 2>&1 &
+	subvol_pid=$!
+	echo "$subvol_pid" >>$seqres.full
+
+	echo "Wait for fsstress to exit and kill all background workers" >>$seqres.full
+	wait $fsstress_pid
+
+	kill $balance_pid $subvol_pid
+	wait
+	# wait for the balance operation to finish
+	while ps aux | grep "balance start" | grep -qv grep; do
+		sleep 1
+	done
+
+	echo "Scrub the filesystem" >>$seqres.full
+	$BTRFS_UTIL_PROG scrub start -B $SCRATCH_MNT >>$seqres.full 2>&1
+	if [ $? -ne 0 ]; then
+		echo "Scrub find errors in \"$mkfs_opts\" test" | tee -a $seqres.full
+	fi
+
+	$BTRFS_UTIL_PROG filesystem sync $SCRATCH_MNT >/dev/null 2>&1
+	# in case the subvolume is still mounted
+	$UMOUNT_PROG $subvol_mnt >/dev/null 2>&1
+	_scratch_unmount
+	_check_scratch_fs
+}
+
+echo "Silence is golden"
+for t in "${tcs[@]}"; do
+	run_test "$t"
+done
+
+status=0
+exit
diff --git a/tests/btrfs/059.out b/tests/btrfs/059.out
new file mode 100644
index 0000000..36ebeea
--- /dev/null
+++ b/tests/btrfs/059.out
@@ -0,0 +1,2 @@ 
+QA output created by 059
+Silence is golden
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 3fa9778..c66c42c 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -61,3 +61,4 @@ 
 056 auto quick
 057 auto quick
 058 auto quick
+059 auto balance subvol